﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;

namespace Infragistics
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();

            var me = new MyClass();
            this.DataContext = me;
        }

    }

    public class MyClass
    {
        public MyItems MyItems { get; set; }

        public MyClass()
        {
            MyItems = new MyItems { Items = GetEmployees() };
        }

        private ObservableCollection<Employee> GetEmployees()
        {
            var retVal = new ObservableCollection<Employee>();
            for( int i = 0; i < 20; i++ )
            {
                var emp = new Employee( i, String.Format( "Name {0}", i ), ( i % 2 == 0 ), DateTime.Now, i % 4, "Here" );
                var stuff = new MyStuff { IsOnline = ( i + 1 ) % 2 == 0, IsStuff = ( i + 1 ) % 3 == 0 };
                emp.MyStuff = stuff;
                retVal.Add( emp );
            }
            return retVal;
        }

    }



    public class MyItems
    {
        public ObservableCollection<Employee> Items { get; set; }
    }

    public class MyStuff
    {
        public bool IsStuff { get; set; }
        public bool IsOnline { get; set; }

        public override string ToString()
        {
            return string.Format( "IsStuff: {0}, IsOnline: {1}", IsStuff, IsOnline );
        }
    }



    public class Employee : INotifyPropertyChanged
    {
        private int employeeID;
        private string name;
        private bool onSite;
        private DateTime dateOfHire;
        private int department;
        private string site;

        public MyStuff MyStuff { get; set; }

        public int EmployeeID
        {
            get { return this.employeeID; }
            set
            {
                this.employeeID = value;
                NotifyPropertyChanged( "EmployeeID" );
            }
        }

        public string Name
        {
            get { return this.name; }
            set
            {
                this.name = value;
                NotifyPropertyChanged( "Name" );
            }
        }

        public bool OnSite
        {
            get { return this.onSite; }
            set
            {
                this.onSite = value;
                NotifyPropertyChanged( "OnSite" );
            }
        }

        public DateTime DateOfHire
        {
            get { return this.dateOfHire; }
            set
            {
                this.dateOfHire = value;
                NotifyPropertyChanged( "DateOfHire" );
            }
        }

        public int Department
        {
            get { return this.department; }
            set
            {
                this.department = value;
                NotifyPropertyChanged( "Department" );
            }
        }
        public string Site
        {
            get { return this.site; }
            set
            {
                this.site = value;
                NotifyPropertyChanged( "Site" );
            }
        }


        public Employee()
        {
            this.employeeID = int.MinValue;
            this.name = string.Empty;
            this.onSite = false;
            this.dateOfHire = DateTime.MinValue;
            this.department = int.MinValue;
            this.site = String.Empty;
        }
        public Employee( int employeeID, string name, bool onSite, DateTime dateOfHire, int department, string site )
        {
            this.employeeID = employeeID;
            this.name = name;
            this.onSite = onSite;
            this.dateOfHire = dateOfHire;
            this.department = department;
            this.site = site;
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged( String info )
        {
            if( PropertyChanged != null )
            {
                PropertyChanged( this, new PropertyChangedEventArgs( info ) );
            }
        }

        #endregion
    }

}
